const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const habit_challenges = sequelize.define(
    'habit_challenges',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

challenge_name: {
        type: DataTypes.TEXT,
      
      

      },

challenge_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"walking",


"no_sugar",


"mindfulness",


"better_sleep",


"water",


"custom"

        ],

      },

start_date: {
        type: DataTypes.DATE,
      
      

      },

end_date: {
        type: DataTypes.DATE,
      
      

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  habit_challenges.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


















































































































//end loop



    db.habit_challenges.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });




    db.habit_challenges.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.habit_challenges.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return habit_challenges;
};


